<?php

class ChatweeV1_HttpClient
{
	const API_URL = "http://chatwee-api.com/api/";

	private $response;

	private $responseStatus;

	private $responseObject;

    public function get($method, $params) {

		$params["chatId"] = ChatweeV1_Configuration::getChatId();
		$params["clientKey"] = ChatweeV1_Configuration::getClientKey();

		$serializedParams = self::_serializeParams($params);

		$url = self::API_URL . $method . "?" . $serializedParams;

		self::_call("GET", $url);
    }

	private function _serializeParams($params) {
		if(!is_array($params) || count($params) == 0) {
			return "";
		}

		$result = "";

		foreach($params as $key => $value) {
			$result .= ($key . "=" . urlencode($value) . '&');
		}

		$result = substr_replace($result, "", -1);
		return $result;
	}

	public function _call($method, $url) {
		$curl = curl_init();

		curl_setopt($curl, CURLOPT_TIMEOUT, 60);
		curl_setopt($curl, CURLOPT_CUSTOMREQUEST, $method);
		curl_setopt($curl, CURLOPT_URL, $url);
		curl_setopt($curl, CURLOPT_ENCODING, 'gzip');
		curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($curl, CURLOPT_HTTPHEADER, Array (
			'Accept: application/xml',
			'Content-Type: application/xml',
			'User-Agent: Chatwee PHP Library '
		));

		$this->response = curl_exec($curl);

		$this->responseStatus = curl_getinfo($curl, CURLINFO_HTTP_CODE);

		curl_close($curl);

		$this->responseObject = $this->response ? json_decode($this->response) : null;

		if($this->responseStatus != 200) {
			$responseError = $this->responseObject ? $this->responseObject->errorMessage : "Chatwee PHP Library unknown error: " . $this->responseStatus;
			$responseError .= " (" . $url . ")";
			throw new Exception($responseError);
		}
    }

	public function getResponse() {
		return $this->response;
	}

	public function getResponseObject() {
		return $this->responseObject;
	}

	public function getResponseStatus() {
		return $this->responseStatus;
	}
}
