<?php

class ChatweeV1_User {

    public static function login($parameters) {
    	if(self::isLogged() === true) {
    		self::logout();
    	}

    	if(isSet($parameters["login"]) === false) {
    		return false;
    	}

		$requestParameters = Array(
			"login" => $parameters["login"],
			"isMobile" => isSet($parameters["isMobile"]) === true ? ($parameters["isMobile"] === true ? 1 : 0) : (ChatweeV1_Utils::isMobileDevice() === true ? 1 : 0),
			"ipAddress" => isSet($parameters["ipAddress"]) === true ? $parameters["ipAddress"] : ChatweeV1_Utils::getUserIp(),
			"isAdmin" => isSet($parameters["isAdmin"]) === true ? ($parameters["isAdmin"] === true ? 1 : 0) : 0,
			"avatar" => isSet($parameters["avatar"]) === true ? htmlentities($parameters["avatar"]) : "",
			"previousSessionId" => isSet($parameters["previousSessionId"]) === true ? $parameters["previousSessionId"] : ChatweeV1_Session::getPreviousSessionId(),
		);

		$httpClient = new ChatweeV1_HttpClient();
		$httpClient->get("remotelogin", $requestParameters);

		$response = $httpClient->getResponseObject();
		$sessionId = $response->sessionId;

		ChatweeV1_Session::setSessionId($sessionId);

		return $sessionId;
    }

	public static function logout() {
		if(self::isLogged() === false) {
			return false;
		}

		$requestParameters = Array(
			"sessionId" => ChatweeV1_Session::getSessionId()
		);

		$httpClient = new ChatweeV1_HttpClient();
		$httpClient->get("remotelogout", $requestParameters);

		$response = $httpClient->getResponseObject();

		ChatweeV1_Session::clearSessionId();
	}

    public static function isLogged() {
		return ChatweeV1_Session::getSessionId() !== null;
    }
}
